<?php

/* NoPro handy-lib
 * some handy defs and funcs
 */

if (!defined('CRLF')) define('CRLF', "\r\n");

function sqltimedate($date) {
  return date("Y-m-d H:i:s", strtotime($date));
}

function sqlstore($tbl, $arr, $idkey = null, $verbose = null) {
  $query = $idkey ? "INSERT INTO $tbl SET" : "UPDATE $tbl SET";
  foreach($arr as $key => $val) {
    if(is_numeric($val))
      $query .= " $key = $val,";
    else
      $query .= " $key = '$val',";
  }
  $query = rtrim($query, ',');
  
  if($idkey)
    $query .= sprintf(" WHERE $idkey = %d", $arr[$idkey]);
  
  if($verbose)
    echo $query ."\n";
  
  mysql_query($query) or die("sqlstore(): ". mysql_error());
  if($idkey)
    $idval = $arr[$idkey];
  else
    $idval = mysql_insert_id();
  return $idval;
}

function npget_http($url) {
  if(function_exists('http_get')) {
    // use pecl http-extension
    $html = http_get($url);
  } else {
    // use curl
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_HEADER, 1);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    $html = html_entity_decode(curl_exec($ch));
    curl_close($ch);
  }
  return $html;
}

function npget_mywebip($k = 0) {
  $pool = array(
		# array("myip.sonyonline.net/", "/-- You Are \r\n../"),		// chunks 30 + ea + 1d + 19 + 3b but needs regex
		## array("myip.dk", 'IP Address:</b> <span class="ha4">'),	// 6024 not working anymore since 2012-09
		## array("myip.utilities-online.info/", "My ip is: "),		// chunks long  not working anymore since 2012-11
		array('whatismyipaddress.com/', '<!-- do not script -->'),	// next line
		array("www.ip-adress.com/IP_adresse/", "Meine IP: "),		// len: 5853 *but slow*
		array("myip.nmonitoring.com/", "<a href='http://whois.nmonitoring.com?ip="),	// chunks VERY long
	       );
  if($k<0 || $k>count($pool)) $k=0;
  list($site, $ptrn) = $pool[$k];

  $html = npget_http("http://$site");  
  #echo $html; exit;
  $line = stristr($html, $ptrn);
  $off = strspn($line, "\r\n\t ", strlen($ptrn));
  $len = strspn($line, ".0123456789", strlen($ptrn) + $off);
  return substr($line, strlen($ptrn) + $off, $len);
}

function htmlify($s) {
  // replace umlauts only
  $patt = array('//',    '//',    '//',    '//',     '//',    '//',    '//');
  $repl = array('&auml;', '&ouml;', '&uuml;', '&szlig;', '&Auml;', '&Ouml;', '&Uuml;');
  return preg_replace($patt, $repl, $s);
}

?>